<template>
  <single-pane capt="Роли пользователей">
    <ob-table
      :items="roles"
      :columns="gridColumns"
      :functional-panel="true"
      :show-add-button="true"
      @select="onSelection"
      @add="onAddRole"
    />
    <ob-modal
      ref="rolesModal"
      size="xl"
      title="Роль пользователя"
    >
      <form-worker-role
        ref="editRole"
        :data-source="editData"
        @close="onCloseForm"
        @save="onSubmitForm"
        @remove="removeLink"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
  import SinglePane from 'common-components/src/obComponents/obSinglePanels';
  import ObTable from 'common-components/src/obComponents/obTable';
  import FormWorkerRole from './modal'
  import ObModal from 'common-components/src/obComponents/obModal'
  import { uuid } from 'vue-uuid'
  import api from '@/api'
  import moment from 'moment'

  export default {
    name: 'UserRoles',
    components: {
      FormWorkerRole,
      ObModal,
      ObTable,
      SinglePane,
    },
    computed: {
      gridColumns () {
        return [
          {
            title: 'Роль участника',
            key: 'contractor_role_title',
          },
          {
            title: 'Роль пользователя',
            key: 'title',
          },
          {
            title: 'Кол-во доступов',
            key: 'functions_count',
            html: ({functions_count}) => functions_count.toString()
          },
          {
            title: 'Статус',
            key: 'is_active',
            html: (role) => role.is_active ? 'Активна' : 'Неактивна'
          },
          {
            title: 'Дата',
            key: 'created_at',
            html: (role) => role.created_at ?  moment(role.created_at).format("DD.MM.YYYY") : ''
          }
        ]
      }
    },
    data() {
      return {
        editData: {},
        roles: []
      }
    },
    mounted() {
      this.getUserRoles()
    },
    methods: {
      async onSelection(userRole) {
        try {
          const functions = await api.functions.getFunctionsAcceptByWorkerRole(userRole.uuid)
          const contractorRoles = await api.user_roles.getContractorRoles()
          const contractor_role_uuid = contractorRoles.find(role => userRole.contractor_role_title === role.title).uuid

          this.editData = {
            ...userRole,
            functions: functions,
            contractor_role_uuid
          }
          this.$nextTick(() => {
            this.$refs.rolesModal.open()
          })
        } catch (e) {
          console.error(e);
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }
      },
      onAddRole() {
        this.editData = {}

        this.$nextTick(() => {
          this.$refs.rolesModal.open()
        })
      },

      onCloseForm() {
        this.editData = {}
      },

      async onSubmitForm(data) {
        const notificationId = `${new Date().getTime()}save`;
        this.$notification({
          type: 'system_notification_in_load',
          message: 'Сохранение',
          id: notificationId
        });
        const links = data.functions.map(({ uuid }) => ({
          function_uuids: uuid,
          uuid: uuid.v4(),
        }));

        try {
          if (data.uuid) {
            const payload = {
              uuid: this.editData.uuid,
              obj: { links }
            }

            await api.user_roles.addWorkerRoleFunctionsLink(payload)
            this.editData.functions = await api.functions.getFunctionsAcceptByWorkerRole(this.editData.uuid)

            await this.getUserRoles();

            this.$notification({
              type: 'system_notification_success',
              message: 'Сохранено'
            });
          }
          else {
            try {
              const body = {
                contractor_role_uuid: data.contractor_role_uuid,
                title: data.userRole,
                uuid: uuid.v4()
              }
              const res = await api.user_roles.addUserRole(body)
              if (!res || (res.code && res.code === 409)) {
                throw new Error(res)
              }
              if (res) {
                await api.user_roles.addWorkerRoleFunctionsLink({
                  uuid: res.uuid,
                  obj: { links }
                })
              } else {
                throw new Error('Ошибка добавления роли пользователя');
              }

              await this.getUserRoles()

              this.$refs.rolesModal.close()
              this.onCloseForm()
              this.$notification({
                type: 'system_notification_success',
                message: 'Сохранено'
              })
            } catch (e) {
              console.error(e);
              this.$notification({
                type: 'system_notification_error',
                message: 'Роль пользователя не должна дублироваться'
              })
            }
          }
        }
        catch (e) {
          console.error(e);
          this.$notification({
            type: 'system_notification_error',
            message: 'Не сохранено'
          })
        }
        finally {
          this.$notification({
            event: 'close',
            id: notificationId
          })
        }
      },

      async removeLink(data) {
        const notificationId = `${new Date().getTime()}remove`;
        try {
          this.$notification({
            type: 'system_notification_in_load',
            message: 'Удаление',
            id: notificationId
          });
          let res = await api.user_roles.deleteWorkerRoleFunctionsLink({
            uuid: this.editData.uuid,
            funcUuid: data.uuid
          })

          const functions = this.editData.functions

          if (res) {
            this.editData.functions = functions.filter(item => item.uuid !== data.uuid)
          }
          this.getUserRoles()
          this.$notification({
            type: 'system_notification_success',
            message: 'Удалено'
          })
        }
        catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Не удалено'
          })
        }
        finally {
          this.$notification({
            event: 'close',
            id: notificationId
          })
        }
      },

      async getUserRoles() {
        api.user_roles.getUserRoles().then(data => {
          this.roles = data
        }).catch((e) => {
          console.error(e);
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        })
      }
    }
  }
</script>

<style lang="scss" scoped>
  .ob-modal-container {
    .data-grid__table {
      max-height: 400px;
      min-height: 300px;
    }
  }
</style>
